// Memory.java                                      MM 2014

import Tools.IO.*;                              // Eingaben

/**
 * Memoryspiel.
 */
public class Memory
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Alle Mitspieler, mindestens zwei.
 */
  Spieler[] spieler;

/**
 * Memoryspiel: Brett und Kartenpaare.
 */
  SpielFeld spiel;

/* ----------------------------------------------------- */
                                                // Programm
/**
 * Spielen.
 */
  public static void main( String[] args)
  {
// Erzeugt ein Memoryspiel
    Memory memory = new Memory();

/* ----------------------------------------------------- */
// Spielfeld
                                // Erzeugen des Spielfeldes
    memory.spiel = new SpielFeld();
    memory.spiel.brett
    = new int[memory.spiel.hoehe][memory.spiel.breite];

             // Anordnen der Kartenpaare auf dem Spielbrett
    int karte = 1;
    for( int z = 0; z < memory.spiel.hoehe; z++)
      for( int s = 0; s < memory.spiel.breite; s++)
        memory.spiel.brett[ z][ s] = ++karte / 2;

                                      // Mischen der Karten
    int m1, n1, m2, n2, dummy;

    for( int i = 0; i < memory.spiel.mischTiefe; i++)
    { m1 = (int)(( memory.spiel.hoehe) * Math.random());
      n1 = (int)(( memory.spiel.breite) * Math.random());
      m2 = (int)(( memory.spiel.hoehe) * Math.random());
      n2 = (int)(( memory.spiel.breite) * Math.random());

      dummy = memory.spiel.brett[ m1][ n1];
      memory.spiel.brett[ m1][ n1]
      = memory.spiel.brett[ m2][ n2];
      memory.spiel.brett[ m2][ n2] = dummy;
    }

/* ------------------------------------------------- */
// Spieler
                              // Einlesen der Spieleranzahl
    int spielerAnzahl =
    IOTools.readInteger( "Wie viel Spieler gibt es? ");

                                    // Erzeugen der Spieler
    memory.spieler = new Spieler[ spielerAnzahl];
    for( int i = 0; i < memory.spieler.length; i++)
      memory.spieler[ i] = new Spieler();

                               // Einlesen der Spielerdaten
    for( int s = 0; s < memory.spieler.length; s++)
    {
      System.out.println( "Spieler "+ (s + 1));
      memory.spieler[ s].vorName
      = IOTools.readLine( "Wie ist Dein Vorname? ");
      memory.spieler[ s].nachName
      = IOTools.readLine( "Wie ist Dein Nachname? ");
    }

/* ----------------------------------------------------- */
// Spiel
    int dran = 0;
    while( memory.spiel.kartenPaare != 0)
    {
                                              // Spielbrett
      for( int z = 0; z < memory.spiel.hoehe; z++)
      {
        for( int s = 0; s < memory.spiel.breite; s++)
        {
          System.out.print( "    ");
          if( memory.spiel.brett[ z][ s] == 0)
            System.out.print( "  ");
          else System.out.print( " X"); 
          System.out.print( " |");
        }
        System.out.println();
      }

      System.out.println
      ( "Spieler "+  memory.spieler[ dran].vorName +
        ", du bist dran! Nimm zwei Karten!");

      do                                         // Karte 1
      {
        m1 = IOTools.readInteger( "");
        n1 = IOTools.readInteger( "");
      }
      while( m1 < 0 || n1 < 0 ||
             m1 >= memory.spiel.hoehe ||
             n1 >= memory.spiel.breite ||
             memory.spiel.brett[ m1][ n1] == 0);

                                // Zwischenstand Spielbrett
      for( int z = 0; z < memory.spiel.hoehe; z++)
      {
        for( int s = 0; s < memory.spiel.breite; s++)
        {
          System.out.print( "    ");

          if( memory.spiel.brett[ z][ s] == 0)
            System.out.print( "  ");
          else
            if( z == m1 && s == n1)
            {
              if( memory.spiel.brett[ z][ s] < 10)
                System.out.print( " ");
              System.out.print
                ( "" + memory.spiel.brett[ z][ s]);
            }
            else System.out.print( " X");

          System.out.print( " |");
        }
        System.out.println();
      }

      do                                         // Karte 2
      {
        m2 = IOTools.readInteger( "");
        n2 = IOTools.readInteger( "");
      }
      while( m1 == m2 && n1 == n2 ||
             m2 < 0 || n2 < 0 ||
             m2 >= memory.spiel.hoehe ||
             n2 >= memory.spiel.breite ||
             memory.spiel.brett[ m2][ n2] == 0);

                                // Zwischenstand Spielbrett
      for( int z = 0; z < memory.spiel.hoehe; z++)
      {
        for( int s = 0; s < memory.spiel.breite; s++)
        {
          System.out.print( "    ");

          if( memory.spiel.brett[ z][ s] == 0)
            System.out.print( "  ");
          else
            if( z == m1 && s == n1 ||
                z == m2 && s == n2)
            {
              if( memory.spiel.brett[ z][ s] < 10)
                System.out.print( " ");
              System.out.print
                ( "" + memory.spiel.brett[ z][ s]);
            }
            else System.out.print( " X");

          System.out.print( " |");
        }
        System.out.println();
      }

                                              // Auswertung
      if( memory.spiel.brett[ m1][ n1]
          == memory.spiel.brett[ m2][ n2])
      {
        System.out.println
        ( "Richtig, das Paar gehoehrt dir!");
        memory.spieler[ dran].gewonnenePaare++;
        memory.spiel.kartenPaare--;
        memory.spiel.brett[ m1][ n1] = 0;
        memory.spiel.brett[ m2][ n2] = 0;
      }
      else
      {                                   // Spielerwechsel
        System.out.println
        ( "Falsch, jetzt ist der Naechste dran!");
        dran++; dran %= memory.spieler.length;
      }

// Kontrollausgabe des Spielbrettes fuer Testzwecke
/*
      for( int z = 0; z < memory.spiel.hoehe; z++)
      {
        for( int s = 0; s < memory.spiel.breite; s++)
        {
          System.out.print( "    ");

          if( memory.spiel.brett[ z][ s] < 10)
            System.out.print( " ");

          System.out.print
          ( "" + memory.spiel.brett[ z][ s] + " |");
        }
        System.out.println();
      }
*/
    }

/* ----------------------------------------------------- */
// Endstand
    System.out.println( "Liste unsortiert: ");
    for( int i = 0; i < memory.spieler.length; i++)
      System.out.println
      ( "Spieler "+ (i + 1) + ": " + 
        memory.spieler[ i].vorName + " " +
        memory.spieler[ i].nachName + ", gewonnen: " + 
        memory.spieler[ i].gewonnenePaare + " Paare.");
  }
}
